# ../addons/eventscripts/corelib/xendround/xendround.py

''' Version 1.1 by L'In20Cible '''

import es
import cmdlib

from configobj import ConfigObj


try: gameinfo = ConfigObj(es.getAddonPath("corelib/xendround") + "/games.ini")[es.getgame()]
except KeyError: gameinfo = None


def xendround_callback(parameters):
   userid = es.getuserid()
   if not userid or gameinfo is None:
      if not es.exists("command", "endround"):
         return # Unfortunately, 'endround' is not supported by this game... :(
      elif es.getInt("sv_cheats"):
         es.server.endround()
      else:
         es.forcevalue("sv_cheats", 1)
         es.server.endround()
         es.forcevalue("sv_cheats", 0)
   else:
      created = False
      if es.getentityindex("info_map_parameters") == -1: # WARNING: The game can't support multiple 'info_map_parameters' entities...
         created = True
         es.createentity("info_map_parameters")
      condition = int(gameinfo["default"])
      if len(parameters):
         if parameters[0].isdigit():
            if int(parameters[0]) in range(int(gameinfo["range"])):
               condition = int(parameters[0])
         else:
            message = str(parameters).replace(" ", "_").replace('"', "").lower() # Format the string so it accept multiple formats...
            if not message.startswith("#"):
               message = "#" + message
            if gameinfo["messages"].has_key(message):
               condition = int(gameinfo["messages"][message])
      es.fire(userid, "info_map_parameters", "FireWinCondition", condition)
      if created:
         es.fire(userid, "info_map_parameters", "kill")
         
cmdlib.registerServerCommand("xendround", xendround_callback, "Ends the current round with the specified condition.\n - Syntax: xendround [condition]")